<template lang="pug">
q-dialog.q-dialog_auth(persistent v-model="OPENED")
	q-card
		q-card-section
			.text-h6 Авторизация
		q-card-section.q-pt-none
			q-form(@submit="onSubmit").q-gutter-md
				ui-input-text(
					v-model.trim="username",
					label="Логин"
					:rules="usernameRules"
					)
					template(v-slot:prepend)
						q-icon(name="alternate_email")

				ui-input-text(
					v-model.trim="password",
					type="password"
					label="Пароль"
					)
					template(v-slot:prepend)
						q-icon(name="vpn_key")

				q-btn(
					label="Войти",
					type="submit",
					color="primary"
					icon="login"
					)

</template>

<script lang="ts">
	import { ref, computed } from 'vue'
	import { useMainStore } from '@/store/main'
	import UiInputText from '@/components/ui/UiInputText.vue'

	export default {
		name: 'TheLoginLayout',

		components: { UiInputText },

		setup() {
			const mainStore = useMainStore()

			const username = ref('')
			const password = ref('')

			return {
				OPENED: true,
				usernameRules: [
					(val: string) => (val && val.length > 0) || 'Укажите логин',
					(val: string) =>
						/^[-._a-z0-9а-я]+@(?:[a-z0-9а-я][-a-z0-9а-я]+\.)+[a-zа-я]{2,6}$/.test(val.toLowerCase()) ||
						'Проверьте корректнность email',
				],
				username,
				password,
				onSubmit: async () => {
					await mainStore.logIn(username.value, password.value)
				},
			}
		},
	}
</script>

<style lang="scss" scoped>
	.q-card {
		width: 400px;
	}
</style>
